/*
Written by Markku Simonen <markku.simonen@helsinki.fi>
3.2.2017
*/

const Applet = imports.ui.applet;
const PopupMenu = imports.ui.popupMenu;
const Util = imports.misc.util;
const GLib = imports.gi.GLib;

//let home = process.env.HOME;

var username = GLib.get_user_name();

var charFirst = username.charAt(0);


function myKoti() {


      if (/^[a-e]/.test(charFirst)) {
        koti = "1";
    } else if (/^[f-j]/.test(charFirst)) {
        koti = "2";
    } else if (/^[k-l]/.test(charFirst)) {
        koti = "3";
    } else if (/^[m-o]/.test(charFirst)) {
        koti = "4";
    } else if (/^[p-s]/.test(charFirst)) {
        koti = "5";
    } else if (/^[t-z]/.test(charFirst)) {
        koti = "6";
    }  
    return koti;
}

var zPath = "smb://cella.ad.helsinki.fi/u" + myKoti() + "/" + charFirst + "/" + username;

var CommandConstants = new function() {
    this.COMMAND_OPEN_HELPDESK = "xdg-open http://www.helsinki.fi/helpdesk";
    this.COMMAND_OPEN_CHAT = "/usr/bin/chromium-browser --window-size=420,540 --app=http://www.helsinki.fi/helpdesk-extra/univmenu_chat/univmenu_chat_index.html";
    this.COMMAND_COMPUTER_INFO = "/etc/cubbli/hy-menu/computerinfo.py";
    this.COMMAND_USER_INFO = "/etc/cubbli/hy-menu/userinfo.py";
    this.COMMAND_INSTALL_PRINTERS = "/etc/cubbli/hy-menu/hy-printers.py";
//    this.COMMAND_INSTALL_SOFTWARE = "/etc/cubbli/hy-menu/hy-software.py";
    this.COMMAND_OPEN_Z = "nemo " + zPath;
//    this.COMMAND_OPEN_P = "nemo";
}

function MyApplet(orientation, panel_height) {
    this._init(orientation, panel_height);
}



MyApplet.prototype = {
    __proto__: Applet.IconApplet.prototype,

    _init: function(orientation, panel_height) {
        Applet.IconApplet.prototype._init.call(this, orientation, panel_height);
        this.set_applet_icon_path("/etc/cubbli/hy-menu/hy-menu.png");
        this.set_applet_tooltip(_("HY-menu"));

        //create a new menu

        this.menuManager = new PopupMenu.PopupMenuManager(this);
        this.menu = new Applet.AppletPopupMenu(this, orientation, panel_height);
        this.menuManager.addMenu(this.menu);

        //show hostname
        this.menu.addMenuItem(new PopupMenu.PopupMenuItem(this._get_hostname(), {reactive:false}));

        //add a separator
        this.menu.addMenuItem(new PopupMenu.PopupSeparatorMenuItem());

        //add web links
        this.menu.addAction(_("Helpdesk in web"), function(event) {
                        Util.spawnCommandLine(CommandConstants.COMMAND_OPEN_HELPDESK);

        });

        this.menu.addAction(_("Chat with Helpdesk"), function(event) {
                        Util.spawnCommandLine(CommandConstants.COMMAND_OPEN_CHAT);
        });

        //add a separator
        this.menu.addMenuItem(new PopupMenu.PopupSeparatorMenuItem());

        //add items and tools
        this.menu.addAction(_("Computer Info"), function(event) {
                        Util.spawnCommandLine(CommandConstants.COMMAND_COMPUTER_INFO);

        });

        this.menu.addAction(_("User Info"), function(event) {
                        Util.spawnCommandLine(CommandConstants.COMMAND_USER_INFO);
        });

//        this.menu.addAction(_("Install Software"), function(event) {
//                        Util.spawnCommandLine(CommandConstants.COMMAND_INSTALL_SOFTWARE);
//        });

        this.menu.addAction(_("Install Printers"), function(event) {
                        Util.spawnCommandLine(CommandConstants.COMMAND_INSTALL_PRINTERS);
        });

	//add a separator
        this.menu.addMenuItem(new PopupMenu.PopupSeparatorMenuItem());

        //add network paths
        this.menu.addAction(_("Open Z-drive"), function(event) {
                        Util.spawnCommandLine(CommandConstants.COMMAND_OPEN_Z);
        });

//        this.menu.addAction(_("Open P-drive"), function(event) {
//                        Util.spawnCommandLine(CommandConstants.COMMAND_OPEN_P);
//        });
    },

    on_applet_clicked: function() {
        this.menu.toggle();
    },

    _get_hostname: function() {
        let check_hostname = GLib.spawn_command_line_sync("hostname")[1].toString();
        let hostname = check_hostname.trim()
        return hostname;
    }
};

function main(metadata, orientation, panel_height) {
    return new MyApplet(orientation, panel_height);
}


/*
"Always be wary of any helpful item that weighs less than its operating manual."
	--Sir Terry Pratchett
*/


